React Spinner Component

Spinner

Indicate the loading state of a component or page with CoreUI spinners, built entirely with HTML, CSS, and no JavaScript.

Available in Other JavaScript Frameworks

CoreUI React Spinner Component is also available for Angular, Bootstrap, and Vue. Explore framework-specific implementations below:

About

CoreUI “spinners” can be used to show the loading state in your projects. They’re built only with HTML and CSS, meaning you don’t need any JavaScript to create them. You will, however, need some custom JavaScript to toggle their visibility. Their appearance, alignment, and sizing can be easily customized with our amazing utility classes.

For accessibility purposes, each loader here includes role="status" and a nested <span className="visually-hidden">Loading...</span>.

Border spinner

Use the border spinners for a lightweight loading indicator.

import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerBorderExample = () => {
  return <CSpinner />
}
import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerBorderExample = () => {
  return <CSpinner />
}

Colors

The border spinner uses currentColor for its border-color. You can use any of our text color utilities on the standard spinner.

import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerBorderColorsExample = () => {
  return (
    <>
      <CSpinner color="primary" />
      <CSpinner color="secondary" />
      <CSpinner color="success" />
      <CSpinner color="danger" />
      <CSpinner color="warning" />
      <CSpinner color="info" />
      <CSpinner color="light" />
      <CSpinner color="dark" />
    </>
  )
}
import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerBorderColorsExample = () => {
  return (
    <>
      <CSpinner color="primary" />
      <CSpinner color="secondary" />
      <CSpinner color="success" />
      <CSpinner color="danger" />
      <CSpinner color="warning" />
      <CSpinner color="info" />
      <CSpinner color="light" />
      <CSpinner color="dark" />
    </>
  )
}

Growing spinner

If you don’t fancy a border spinner, switch to the grow spinner. While it doesn’t technically spin, it does repeatedly grow!

import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerGrowExample = () => {
  return <CSpinner variant="grow" />
}
import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerGrowExample = () => {
  return <CSpinner variant="grow" />
}

Once again, this spinner is built with currentColor, so you can easily change its appearance. Here it is in blue, along with the supported variants.

import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerGrowColorsExample = () => {
  return (
    <>
      <CSpinner color="primary" variant="grow" />
      <CSpinner color="secondary" variant="grow" />
      <CSpinner color="success" variant="grow" />
      <CSpinner color="danger" variant="grow" />
      <CSpinner color="warning" variant="grow" />
      <CSpinner color="info" variant="grow" />
      <CSpinner color="light" variant="grow" />
      <CSpinner color="dark" variant="grow" />
    </>
  )
}
import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerGrowColorsExample = () => {
  return (
    <>
      <CSpinner color="primary" variant="grow" />
      <CSpinner color="secondary" variant="grow" />
      <CSpinner color="success" variant="grow" />
      <CSpinner color="danger" variant="grow" />
      <CSpinner color="warning" variant="grow" />
      <CSpinner color="info" variant="grow" />
      <CSpinner color="light" variant="grow" />
      <CSpinner color="dark" variant="grow" />
    </>
  )
}

Alignment

CoreUI React spinners are built with rems, currentColor, and display: inline-flex. This means they can easily be resized, recolored, and quickly aligned.

Margin

Use margin utilities like .m-5 for easy spacing.

import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerBorderMarginExample = () => {
  return <CSpinner className="m-5" />
}
import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerBorderMarginExample = () => {
  return <CSpinner className="m-5" />
}

Placement

Use flexbox utilities, float utilities, or text alignment utilities to place spinners exactly where you need them in any situation.

Flex

import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerBorderPlacementFlexExample = () => {
  return (
    <div className="d-flex justify-content-center">
      <CSpinner />
    </div>
  )
}
import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerBorderPlacementFlexExample = () => {
  return (
    <div className="d-flex justify-content-center">
      <CSpinner />
    </div>
  )
}
import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerBorderPlacementFlex2Example = () => {
  return (
    <div className="d-flex align-items-center">
      <strong role="status">Loading...</strong>
      <CSpinner className="ms-auto" />
    </div>
  )
}
import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerBorderPlacementFlex2Example = () => {
  return (
    <div className="d-flex align-items-center">
      <strong role="status">Loading...</strong>
      <CSpinner className="ms-auto" />
    </div>
  )
}

Floats

import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerBorderPlacementFloatsExample = () => {
  return (
    <div className="clearfix">
      <CSpinner className="float-end" />
    </div>
  )
}
import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerBorderPlacementFloatsExample = () => {
  return (
    <div className="clearfix">
      <CSpinner className="float-end" />
    </div>
  )
}

Text align

import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerBorderPlacementTextAlignExample = () => {
  return (
    <div className="text-center">
      <CSpinner />
    </div>
  )
}
import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerBorderPlacementTextAlignExample = () => {
  return (
    <div className="text-center">
      <CSpinner />
    </div>
  )
}

Size

Add size="sm" property to make a smaller spinner that can quickly be used within other components.

import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerSizeSmallExample = () => {
  return (
    <>
      <CSpinner size="sm" />
      <CSpinner size="sm" variant="grow" />
    </>
  )
}
import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerSizeSmallExample = () => {
  return (
    <>
      <CSpinner size="sm" />
      <CSpinner size="sm" variant="grow" />
    </>
  )
}

Or, use custom CSS or inline styles to change the dimensions as needed.

import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerSizeCustomExample = () => {
  return (
    <>
      <CSpinner style={{ width: '3rem', height: '3rem' }} />
      <CSpinner variant="grow" style={{ width: '3rem', height: '3rem' }} />
    </>
  )
}
import React from 'react'
import { CSpinner } from '@coreui/react'

export const SpinnerSizeCustomExample = () => {
  return (
    <>
      <CSpinner style={{ width: '3rem', height: '3rem' }} />
      <CSpinner variant="grow" style={{ width: '3rem', height: '3rem' }} />
    </>
  )
}

Buttons

Use spinners within buttons to indicate an action is currently processing or taking place. You may also swap the text out of the spinner element and utilize button text as needed.

import React from 'react'
import { CButton, CSpinner } from '@coreui/react'

export const SpinnerButtonsExample = () => {
  return (
    <>
      <CButton color="primary" disabled>
        <CSpinner as="span" size="sm" aria-hidden="true" />
        <span className="visually-hidden" role="status">
          Loading...
        </span>
      </CButton>
      <CButton color="primary" disabled>
        <CSpinner as="span" className="me-2" size="sm" aria-hidden="true" />
        <span role="status">Loading...</span>
      </CButton>
    </>
  )
}
import React from 'react'
import { CButton, CSpinner } from '@coreui/react'

export const SpinnerButtonsExample = () => {
  return (
    <>
      <CButton color="primary" disabled>
        <CSpinner as="span" size="sm" aria-hidden="true" />
        <span className="visually-hidden" role="status">
          Loading...
        </span>
      </CButton>
      <CButton color="primary" disabled>
        <CSpinner as="span" className="me-2" size="sm" aria-hidden="true" />
        <span role="status">Loading...</span>
      </CButton>
    </>
  )
}
import React from 'react'
import { CButton, CSpinner } from '@coreui/react'

export const SpinnerButtons2Example = () => {
  return (
    <>
      <CButton color="primary" disabled>
        <CSpinner as="span" size="sm" variant="grow" aria-hidden="true" />
        <span className="visually-hidden" role="status">
          Loading...
        </span>
      </CButton>
      <CButton color="primary" disabled>
        <CSpinner as="span" className="me-2" size="sm" variant="grow" aria-hidden="true" />
        <span role="status">Loading...</span>
      </CButton>
    </>
  )
}
import React from 'react'
import { CButton, CSpinner } from '@coreui/react'

export const SpinnerButtons2Example = () => {
  return (
    <>
      <CButton color="primary" disabled>
        <CSpinner as="span" size="sm" variant="grow" aria-hidden="true" />
        <span className="visually-hidden" role="status">
          Loading...
        </span>
      </CButton>
      <CButton color="primary" disabled>
        <CSpinner as="span" className="me-2" size="sm" variant="grow" aria-hidden="true" />
        <span role="status">Loading...</span>
      </CButton>
    </>
  )
}

API

Check out the documentation below for a comprehensive guide to all the props you can use with the components mentioned here.

Vue Spinner Component

Spinner

Indicate the loading state of a component or page with CoreUI spinners, built entirely with HTML, CSS, and no JavaScript.

Available in Other JavaScript Frameworks

CoreUI Vue Spinner Component is also available for Angular, Bootstrap, and React. Explore framework-specific implementations below:

About

CoreUI “spinners” can be used to show the loading state in your projects. They’re built only with HTML and CSS, meaning you don’t need any JavaScript to create them. You will, however, need some custom JavaScript to toggle their visibility. Their appearance, alignment, and sizing can be easily customized with our amazing utility classes.

For accessibility purposes, each loader here includes role="status" and a nested <span class="visually-hidden">Loading...</span>.

Border spinner

Use the border spinners for a lightweight loading indicator.

Basic usage

vue
<template>
  <CSpinner />
</template>

<script setup>
import { CSpinner } from '@coreui/vue'
</script>

Colors

The border spinner uses currentColor for its border-color. You can use any of our text color utilities on the standard spinner.

vue
<template>
  <CSpinner color="primary" />
  <CSpinner color="secondary" />
  <CSpinner color="success" />
  <CSpinner color="danger" />
  <CSpinner color="warning" />
  <CSpinner color="info" />
  <CSpinner color="light" />
  <CSpinner color="dark" />
</template>

<script setup>
import { CSpinner } from '@coreui/vue'
</script>

Growing spinner

If you don’t fancy a border spinner, switch to the grow spinner. While it doesn’t technically spin, it does repeatedly grow!

vue
<template>
  <CSpinner variant="grow" />
</template>

<script setup>
import { CSpinner } from '@coreui/vue'
</script>

Once again, this spinner is built with currentColor, so you can easily change its appearance. Here it is in blue, along with the supported variants.

vue
<template>
  <CSpinner color="primary" variant="grow" />
  <CSpinner color="secondary" variant="grow" />
  <CSpinner color="success" variant="grow" />
  <CSpinner color="danger" variant="grow" />
  <CSpinner color="warning" variant="grow" />
  <CSpinner color="info" variant="grow" />
  <CSpinner color="light" variant="grow" />
  <CSpinner color="dark" variant="grow" />
</template>

<script setup>
import { CSpinner } from '@coreui/vue'
</script>

Size

Add size="sm"property` to make a smaller spinner that can quickly be used within other components.

vue
<template>
  <CSpinner size="sm" />
  <CSpinner size="sm" variant="grow" />
</template>

<script setup>
import { CSpinner } from '@coreui/vue'
</script>

Buttons

Use spinners within buttons to indicate an action is currently processing or taking place. You may also swap the text out of the spinner element and utilize button text as needed.

vue
<template>
  <CButton color="primary" disabled>
    <CSpinner as="span" size="sm" aria-hidden="true" />
  </CButton>
  <CButton color="primary" disabled>
    <CSpinner as="span" size="sm" aria-hidden="true" />
    Loading...
  </CButton>
</template>

<script setup>
import { CButton, CSpinner } from '@coreui/vue'
</script>
vue
<template>
  <CButton color="primary" disabled>
    <CSpinner as="span" size="sm" variant="grow" aria-hidden="true" />
  </CButton>
  <CButton color="primary" disabled>
    <CSpinner as="span" size="sm" variant="grow" aria-hidden="true" />
    Loading...
  </CButton>
</template>

<script setup>
import { CButton, CSpinner } from '@coreui/vue'
</script>

Angular Spinner Component

Spinner

Indicate the loading state of a component or page with CoreUI Angular spinners.

Available in Other JavaScript Frameworks

CoreUI Angular Spinner Component is also available for Bootstrap, React, and Vue. Explore framework-specific implementations below:

About

CoreUI “spinners” can be used to show the loading state in your projects. They’re built only with HTML and CSS, meaning you don’t need any JavaScript to create them. You will, however, need some custom JavaScript to toggle their visibility. Their appearance, alignment, and sizing can be easily customized with our amazing utility classes.

For accessibility purposes, each loader here includes role="status" and a nested

<span class="visually-hidden">Loading...</span>

Examples

Border spinner

Use the border spinners for a lightweight loading indicator.

import { Component } from '@angular/core';
import { SpinnerComponent } from '@coreui/angular';

@Component({
  selector: 'docs-spinner-border',
  templateUrl: './spinner-border.component.html',
  imports: [SpinnerComponent]
})
export class SpinnerBorderComponent {}
<c-spinner />
<c-spinner>
  <span class="visually-hidden">Loading status...</span>
</c-spinner>

Colors

The border spinner uses currentColor for its border-color. You can use any of our text color utilities on the standard spinner.

import { Component } from '@angular/core';
import { SpinnerComponent } from '@coreui/angular';

@Component({
  selector: 'docs-spinner-colors',
  templateUrl: './spinner-colors.component.html',
  imports: [SpinnerComponent]
})
export class SpinnerColorsComponent {}
<c-spinner color="primary" />
<c-spinner color="secondary" />
<c-spinner color="success" />
<c-spinner color="danger" />
<c-spinner color="warning" />
<c-spinner color="info" />
<c-spinner color="light" />
<c-spinner color="dark" />

Growing spinner

If you don’t fancy a border spinner, switch to the grow spinner. While it doesn’t technically spin, it does repeatedly grow!.

import { Component } from '@angular/core';
import { SpinnerComponent } from '@coreui/angular';

@Component({
  selector: 'docs-spinner-growing',
  templateUrl: './spinner-growing.component.html',
  imports: [SpinnerComponent]
})
export class SpinnerGrowingComponent {}
<c-spinner variant="grow" />

Once again, this spinner is built with currentColor, so you can easily change its appearance. Here it is with supported variants.

import { Component } from '@angular/core';
import { SpinnerComponent } from '@coreui/angular';

@Component({
  selector: 'docs-spinner-growing-2',
  templateUrl: './spinner-growing-2.component.html',
  imports: [SpinnerComponent]
})
export class SpinnerGrowing2Component {}
<c-spinner color="primary" variant="grow" />
<c-spinner color="secondary" variant="grow" />
<c-spinner color="success" variant="grow" />
<c-spinner color="danger" variant="grow" />
<c-spinner color="warning" variant="grow" />
<c-spinner color="info" variant="grow" />
<c-spinner color="light" variant="grow" />
<c-spinner color="dark" variant="grow" />

Size

Add size="sm" property to make a smaller spinner that can quickly be used within other components.

import { Component } from '@angular/core';
import { SpinnerComponent } from '@coreui/angular';

@Component({
  selector: 'docs-spinner-size',
  templateUrl: './spinner-size.component.html',
  imports: [SpinnerComponent]
})
export class SpinnerSizeComponent {}
<c-spinner size="sm" />
<c-spinner size="sm" variant="grow" />

Buttons

Use spinners within buttons to indicate an action is currently processing or taking place. You may also swap the text out of the spinner element and utilize button text as needed.

import { Component } from '@angular/core';
import { ButtonDirective, SpinnerComponent } from '@coreui/angular';

@Component({
  selector: 'docs-spinner-buttons',
  templateUrl: './spinner-buttons.component.html',
  imports: [ButtonDirective, SpinnerComponent]
})
export class SpinnerButtonsComponent {}
<button cButton class="m-1" disabled>
  <c-spinner aria-hidden="true" size="sm" />
</button>
<button cButton class="m-1" disabled>
  <c-spinner aria-hidden="true" size="sm" />
  Loading...
</button>
import { Component } from '@angular/core';
import { ButtonDirective, SpinnerComponent } from '@coreui/angular';

@Component({
  selector: 'docs-spinner-buttons-2',
  templateUrl: './spinner-buttons-2.component.html',
  imports: [ButtonDirective, SpinnerComponent]
})
export class SpinnerButtons2Component {}
<button cButton class="m-1" disabled>
  <c-spinner aria-hidden="true" size="sm" variant="grow" />
</button>
<button cButton class="m-1" disabled>
  <c-spinner aria-hidden="true" size="sm" variant="grow" />
  Loading...
</button>

API reference

Spinner Module

import { SpinnerModule } from '@coreui/angular';

@NgModule({
    imports: [SpinnerModule,]
})
export class AppModule() { }

c-spinner

component

jsx
import { SpinnerComponent } from '@coreui/angular'
PropertyDefaultType
color-string

Sets the color context of the component to one of CoreUI’s themed colors.

label'Loading...'string

Label for accessibility.

role'status'string

Default role attr for spinner

size-'sm'

Size the component small.

variant'border''border', 'grow'

Set the button variant to an outlined button or a ghost button.